/***************************************************************************
 *   Copyright (C) 2007 by Dr. Feynman                                     *
 *   dr@feynman.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "../src/feynman.h"
#include "../src/feynman_win32.h"

int test_del_handle(t_feynman_local_server *server, int start, int end, int id)
{
    int i = 0;

	t_feynman_handle *handle_to_del = feynman_get_handle(server, id);
    feynman_del_handle(server, handle_to_del);

    for(i=start; i<end; i++)
    {
        t_feynman_handle *handle = feynman_get_handle(server, i);
        if(handle == NULL)
        {
            if(i != id)
            {
                printf("ERROR: failed to get fd %d after a delete\n", i);
                return -1;
            }
        }
    }

    feynman_add_handle(server, id);

    return 0;
}

void test_handle_list()
{
    int i = 0;
    t_feynman_handle *handle = NULL;
    t_feynman_local_server *server = feynman_add_local_server(NULL);

    for(i=1; i<60; i++)
    {
        handle = feynman_add_handle(server, i);
        if(handle == NULL)
        {
            printf("ERROR: failed to add fd %d\n", i);
            return;
        }
    }

    printf("Passed add test\n");

    for(i=1; i<60; i++)
    {
        handle = feynman_get_handle(server, i);
        if(handle == NULL)
        {
            printf("ERROR: failed to get fd %d\n", i);
            return;
        }
    }

    printf("Passed get test\n");

    if(test_del_handle(server, 1, 60, 1)) return;
    printf("Passed first del test\n");

    if(test_del_handle(server, 1, 60, 59)) return;
    printf("Passed last del test\n");

    if(test_del_handle(server, 1, 60, 30)) return;
    printf("Passed middle del test\n");

    printf("Handlelist OK\n");

    for(handle=server->handle_db; handle!=NULL; handle=handle->next)
    {
        printf("%d\n", handle->fd);
    }
}

int main(int argc, char *argv[])
{
    test_handle_list();
    return EXIT_SUCCESS;
}
